/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import * as runtime from '../runtime';
import {
  SendMessageResponse,
  SendMessageResponseFromJSON,
  SendMessageResponseToJSON,
  TransferRequest,
  TransferRequestFromJSON,
  TransferRequestToJSON,
  TransferResponse,
  TransferResponseFromJSON,
  TransferResponseToJSON,
} from '../models';

export interface PacsMessagesControllerImplApiSendPacs002MessageRequest {
  transferResponse: TransferResponse;
}

export interface PacsMessagesControllerImplApiSendPacs009MessageRequest {
  transferRequest: TransferRequest;
}

/**
 *
 */
export class PacsMessagesControllerImplApi extends runtime.BaseAPI {
  /**
   * Send PACS 002 message (confirms or rejects a transaction)
   */
  async sendPacs002MessageRaw(
    requestParameters: PacsMessagesControllerImplApiSendPacs002MessageRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<SendMessageResponse>> {
    if (
      requestParameters.transferResponse === null ||
      requestParameters.transferResponse === undefined
    ) {
      throw new runtime.RequiredError(
        'transferResponse',
        'Required parameter requestParameters.transferResponse was null or undefined when calling sendPacs002Message.'
      );
    }

    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    headerParameters['Content-Type'] = 'application/json';

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/pacs/messages/pacs-002-001-12`,
        method: 'POST',
        headers: headerParameters,
        query: queryParameters,
        body: TransferResponseToJSON(requestParameters.transferResponse),
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      SendMessageResponseFromJSON(jsonValue)
    );
  }

  /**
   * Send PACS 002 message (confirms or rejects a transaction)
   */
  async sendPacs002Message(
    requestParameters: PacsMessagesControllerImplApiSendPacs002MessageRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<SendMessageResponse> {
    const response = await this.sendPacs002MessageRaw(
      requestParameters,
      initOverrides
    );
    return await response.value();
  }

  /**
   * Send PACS 009 message
   */
  async sendPacs009MessageRaw(
    requestParameters: PacsMessagesControllerImplApiSendPacs009MessageRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<SendMessageResponse>> {
    if (
      requestParameters.transferRequest === null ||
      requestParameters.transferRequest === undefined
    ) {
      throw new runtime.RequiredError(
        'transferRequest',
        'Required parameter requestParameters.transferRequest was null or undefined when calling sendPacs009Message.'
      );
    }

    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    headerParameters['Content-Type'] = 'application/json';

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/pacs/messages/pacs-009-001-10`,
        method: 'POST',
        headers: headerParameters,
        query: queryParameters,
        body: TransferRequestToJSON(requestParameters.transferRequest),
      },
      initOverrides
    );

    return new runtime.JSONApiResponse(response, (jsonValue) =>
      SendMessageResponseFromJSON(jsonValue)
    );
  }

  /**
   * Send PACS 009 message
   */
  async sendPacs009Message(
    requestParameters: PacsMessagesControllerImplApiSendPacs009MessageRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<SendMessageResponse> {
    const response = await this.sendPacs009MessageRaw(
      requestParameters,
      initOverrides
    );
    return await response.value();
  }
}
